---
layout: markdown_page
title: "GitHub"
---
<!-- This is the template for defining sections which will be included in a tool comparison page. This .md file is included in the top of the page and a table of feature comparisons is added directly below it. This template provides the sections which can be included, and the order to include them. If a section has no content yet then leave it out. Leave this note in tact so that others can see where new sections should be added.

## Summary
   - minimal requirement <-- comment. delete this line
## Strengths
## Weaknesses
## Who buys and why
## Comments/Anecdotes
   - possible customer issues with product  <-- comment. delete this line
   - sample benefits and success stories  <-- comment. delete this line
   - date, source, insight  <-- comment. delete this line
## Resources
   - links to communities, etc  <-- comment. delete this line
   - bulleted list  <-- comment. delete this line
## FAQs
 - about the product  <-- comment. delete this line
## Integrations
## Pricing
   - summary, links to tool website  <-- comment. delete this line
### Value/ROI
   - link to ROI calc?  <-- comment. delete this line
## Questions to ask
   - positioning questions, traps, etc.  <-- comment. delete this line
## Comparison
   - features comparison table will follow this <-- comment. delete this line

<!------------------Begin page additions below this line ------------------ -->

## On this page
{:.no_toc}

- TOC
{:toc}

## Overview

<div class="sdlc-component-container">
  <%= partial "includes/sdlc_comparison_tabs_vue" %>
</div>

<style>
   .flex-cell:nth-of-type(3) {
      display: none;
   }
</style>

## Summary

[GitLab vs.GitHub](https://www.youtube.com/watch?v=s8DCpG1PeaU&feature=youtu.be) - a comparison video created by an independent external source (LinuxHint.com).

GitHub is a collaborative code repository to host and review code, manage projects and build software. It offers all of the distributed version control and source code management (SCM) functionality of Git as well as adding its own features. It provides access control and several collaboration features such as bug tracking, feature requests, task management, and wikis for every project.

The GitHub Actions feature enables code snippets to be run in a container upon a wide variety of GitHub API calls. This has the promise of enabling users to orchestrate their workflows based on any event. With GitHub Actions, workflows and steps are just code in a repository. Actions enable GitHub to offer CI/CD, which makes it easier to automate how you build, test, and deploy your projects and includes runner support for Linux, MacOS, and Windows. It runs your workflows in a container or in a virtual machine.

Similarly, GitLab has integrated CI/CD, but also offers additional capabilities such as application performance and server monitoring. GitLab also includes static and dynamic security testing and container scanning.

GitHub does not come with a deployment platform and needs additional applications, like Heroku, in order to deploy applications. GitLab leverages [Kubernetes](/solutions/kubernetes/) to create a seamless deployment experience in a single application.

GitHub offers plans for both private repositories and free accounts which are commonly used to host open-source software projects. As of June 2018, GitHub reports having over 28 million users and 57 million repositories (including 28 million public repositories), making it the largest host of source code in the world.

On June 4, 2018, Microsoft announced it had reached an agreement to acquire GitHub for US$7.5 billion. The purchase is expected to close by the end of the year.

GitHub is also offered in a self-managed version called GitHub Enterprise (GHE).


## [A GitLab user’s guide to GitHub’s new features - 2019-05-23](https://about.gitlab.com/blog/2019/05/23/gitlab-features-compared-github/)
On May, 23, 2019 at the GitHub’s Satellite developer conference, GitHub announced a number of new features. Here is a [blog post summary](https://about.gitlab.com/blog/2019/05/23/gitlab-features-compared-github/) of what GitHub announced today and how that relates to GitLab features that already exist or are on the public GitLab direction page.

## Comments/Anecdotes
- Feedback from customers is that GitHub Enterprise (GHE) has trouble scaling. It seems like anyone nearing 2k users starts to run into issues. [GitLab is enterprise class](/solutions/enterprise-class/) and scales to > 32K users.
- 2018-09-10 - GitHub announces that [Microsoft Azure Pipelines are available in the GitHub Marketplace](https://blog.github.com/2018-09-10-azure-pipelines-now-available-in-github-marketplace/). This is in parallel with Microsoft (who recently acquired GitHub) announcing their Azure DevOps (rebranded VSTS/TFS). Related? Yes!
- 2018-09-10 - Microsoft announces the [addition of GitHub Pull Requests integrated directly into Visual Studio Code](https://code.visualstudio.com/blogs/2018/09/10/introducing-github-pullrequests). Visual Studio Code is [Microsoft's lightweight (but still not web based) code editor](https://azure.microsoft.com/en-us/products/visual-studio-code/).
- Statement from GitLab PS on 2018-11-12 - For scaling the fact that GitLab is so open makes it much easier to scale - especially for specific workloads. For GitHub Enterprise it’s a black box - only way to scale is “add another box”. Whereas GitLab can utilize cloud native technology - like Kubernetes or AWS tooling to scale.
- 2019-05-10 - GitHub recently announced a limited public beta for [GitHub Package Registry](https://github.com/features/package-registry).  From the website: "With GitHub Package Registry you can safely publish and consume packages within your organization or with the entire world."
- GitLab has been embarking on a single application for the entire DevOps lifecycle since combining CI with SCM in 2012, and released integrated packaging back in 2016 - starting with a Docker registry - and adding Maven and NPM in 2018 . Our public direction for adding RubyGems, Linux packages and Helm Charts is available [here](https://about.gitlab.com/direction/package/).  The private, secure container registry and artifact repositories are built-in and preconfigured to work seamlessly with GitLab source code management and CI/CD pipelines.

## Resources
* [GitHub Website](https://www.github.com/)
* [How GitLab is Enterprise Class](https://about.gitlab.com/solutions/enterprise-class/) - written with GitHub Enterprise claims in mind
* [GitHub Package Registry](https://github.com/features/package-registry)
* [GitHub Actions page](https://github.com/features/actions)

## FAQs

### Distribution architecture
{:.no_toc}

Q:  Is GHE based on a closed VM
A: Yes - [From GitHub Admin Guide](https://help.github.com/enterprise/2.13/admin/guides/installation/)
“GitHub Enterprise is distributed as a virtual machine image that you install and manage within your existing infrastructure.”

Possible disadvantages of a closed VM:

Q:  a closed environment (could be a trojan inside!)
A: Agree with assessment

Q:  Installation is quite complicated
A: DISAGREE - single VM makes it easy to install, although less flexible
[See installation instructions](https://help.github.com/enterprise/2.13/admin/guides/installation/setting-up-a-github-enterprise-instance/)

Q: upgrades and patching is complicated
A: DISAGREE - VM appliance makes patching and upgrading relatively simple.
[See upgrade instructions](https://help.github.com/enterprise/2.13/admin/guides/installation/upgrading-github-enterprise/)

Q:  bad thing off my head for using VM is I/O
A: Not clear - In general yes. But things can be tuned to improve it a lot
See [general recent study on this](https://academic.oup.com/comjnl/article/61/6/808/4259797).

Q: probably can't separate the installation to separated parts (in order to improve performance)
A: DISAGREE - Can have VM act as different parts to scale per requirements. See [GitHub Enterprise Clustering Guide - Cluster design recommendations](https://help.github.com/enterprise/2.13/admin/guides/clustering/about-cluster-nodes/#cluster-design-recommendations) and [GitHub Enterprise Clustering Guide - Initializing-the-cluster](https://help.github.com/enterprise/2.13/admin/guides/clustering/initializing-the-cluster/) for more details.

## GitHub Actions Pricing
* Public repositories - free
* Private repositories - 2k hosted CI minutes and up
* Addional hosted minutes
   * Linux - $.008/min
   * Windows - $.016/min
   * macOS - $.08/min
* https://github.com/features/actions

## Comparison
